#% Ej 10

import numpy as np
from matplotlib import pyplot
import matplotlib.pyplot as plt
from scipy import special

#%%
def dW(delta_t: float) -> float:
#    """Sample a random number at each call."""
    return np.random.randn()*np.sqrt(delta_t)

def model_ej_10(t: float, x: float):
        return np.exp(x)

def run_simulation_ej_10():
#    """ Return the result of one full simulation."""
    T_INIT = 0
    T_END = 1
    N = 1000  # Compute at 1000 grid points
    DT = float(T_END - T_INIT) / N
    TS = np.arange(T_INIT, T_END + DT, DT)


    Y_INIT = 0

    ys = np.zeros(TS.size)
    ys[0] = Y_INIT
    W = 0
    for i in range(1, TS.size):
        t = T_INIT + (i - 1) * DT
        ddW = dW(DT)
        y = ys[i - 1]
        ys[i] = y + model_ej_10(t, W)*ddW
        W = W + ddW
    return TS, ys


def plot_simulations_ej_10(num_sims: int):
#    """ Plot several simulations in one image."""
    y_final = np.zeros(num_sims)
    fig = pyplot.figure()
    fig.set_figheight(8)
    fig.set_figwidth(12)
    for k in range(num_sims):
        [T, y] = run_simulation_ej_10()
        plt.plot(T,y)
        y_final[k] = y[-1]**2
    plt.xlabel("time")
    plt.ylabel("y")
    plt.show()
    return y_final



nsims = 10000
y_final = plot_simulations_ej_10(nsims)

#%%
print('Mean', np.mean(y_final))

print('th_mean',(1/2)*(np.exp(2)- 1))